
#include "GraphWinAGD.h"
#include <AGD/PlanAugOpt.h>
#include <AGD/MaximumPlanarSubgraph.h>


class GraphWinAGDopt : public GraphWinAGD
{
public:

	GraphWinAGDopt();

	~GraphWinAGDopt() { }


	static void callPlanAugOpt (GraphWin& GW) {
		GraphWinAGDopt &gwAGD = (GraphWinAGDopt&)GW;
		callAugment (gwAGD, gwAGD.plan_aug_opt);
	}

	static void callPlanSubOpt (GraphWin& GW) {
		GraphWinAGDopt &gwAGD = (GraphWinAGDopt&)GW;
		callSubgraph (gwAGD, gwAGD.plan_sub_opt);
	}

protected:
	void optionsStraight();
	void optionsPlanarDraw();
	void optionsMixedModel();
	void optionsPlanarization();

	int opt_ps_augment;
	int opt_pd_augment;
	int opt_mm_augment;

	PlanAugOpt plan_aug_opt;
	MaximumPlanarSubgraph plan_sub_opt;
};
