void GraphWinAGD::callRandomHierarchy (GraphWin& gw)
{
	int num_nodes,num_edges,_numberOfLayers;
	char  *filename = "MYCHECK";
	ifstream input(filename,ios::in);
	input >> num_nodes >> num_edges >> _numberOfLayers;

	bool old_flush=gw.set_flush(false); 
	gw.clear_graph();
	graph& G=gw.get_graph();

	// create new graph (by input file)
	// and compute grid coordinates

	node_map<int> x(G,0), y(G,0);  // holds grid layout
	edge_map<IPolyline> bends(G);

	int _source;
	int _sink, i;

	for(i=0;i < num_nodes;i++)
		G.new_node();

	array<node> nodes(num_nodes);
	array<int>  first(_numberOfLayers);


	/** Place nodes **/

    node v;
    int  _vertex;
    int  _layer;
    for(i=0; i < _numberOfLayers;i++)
		first[i]=0;

    forall_nodes(v,G) {
		input >> _vertex >> _layer;
		nodes[_vertex] = v;
        x[nodes[_vertex]] =_layer;
        y[nodes[_vertex]] = first[_layer]++;
    }


	int _found = 0; 
	for (i = 1; i <= num_nodes; i++) {
		input >> _source;
		_found = 0;
		while (!_found) {
			input >> _sink;
			if (_sink != 0)
				G.new_edge(nodes[_source],nodes[_sink]);
			else 
				_found = 1;
		}
	}
	gw.update_graph();


	// assign layout

	GraphWinInterface A (gw);
	A.init(G);

	MaxAllMapper gcm(5,5,5);  // first arg is separation
	gcm.call(G,x,y,bends,IRect(),A);

	A.update();
	A.cleanup();
}
