//-------------------------------------------------------------------
//
//                            misc.h
//
//    author: Carsten Gutwenger
//    date:   february 1997
//-------------------------------------------------------------------


#ifndef _AGD_IMPL_MISC_H
#define _AGD_IMPL_MISC_H


#include <LEDA/array.h>
#include <LEDA/list.h>


template<class E>
void init (leda_array<E> &A, E x)
{
   int i;
   for (i = A.low(); i <= A.high(); i++)
      A[i] = x;
}

template<class E>
list_item get (const leda_list<E> &L, list_item it_start, int pos)
{
   if (L.empty()) return nil;
	list_item it = it_start;
	int k = pos % L.length();

	for (int i = 1; i <= k; i++, it = L.cyclic_succ (it)) ;
	return it;
}

template<class E>
void reverse_list (leda_list<E>& L)
{
	list_item it;
	leda_list<list_item> items;

	forall_items (it, L)
		items.append(it);

	forall (it, items)
		L.move_to_front (it);
}


#endif
