//-------------------------------------------------------------------
//
//                         Keymapper.cpp
//
//    author: Carsten Gutwenger
//    date:   july 1997
//-------------------------------------------------------------------


#include <AGD/Keymapper.h>


Keymapper::Keymapper()
{
	//id_counter = 0;
	stringToKey = h_array<string,agd_key>(nil);
}

Keymapper::~Keymapper()
{
#ifndef _MSC_VER
/*	string str;

	forall_defined (str,stringToKey) {
		delete stringToKey[str];
	}*/

	agd_key k;

	forall (k, _keys)
		delete k;
#endif
}

agd_key Keymapper::get_key (const string& str)
{
	slist_item it;
	agd_key k = stringToKey[str];

	if (k == nil) { // str not in hash table ?
		k = new AGD_Key (str, _keys.length()); // create a new key
		it = _keys.append (k);
		k->pos_in_list = it;
		stringToKey[str] = k; // put str into hash table
	}

	return k;
}

agd_key Keymapper::first_key() const
{
	slist_item it = _keys.first();

	return (it != nil) ? _keys.contents(it) : nil;
}

agd_key Keymapper::next_key (agd_key k) const
{
	slist_item it = _keys.succ(k->pos_in_list);

	return (it != nil) ? _keys.contents(it) : nil;
}

