/************************************************************************

         Filename   :   adjlists.cc

         Version    :   09.1994

         Author     :   Sebastian Leipert

         Language   :   C++

  File containing the procedures of the class adjlists.

************************************************************************/ 





#include <AGD/impl/MaxPlanSub/adjlists.h>
#include <stdio.h>
#include <stdlib.h>
#include <AGD/impl/MaxPlanSub/def.glb>


adjlists::adjlists(int m)
{
   m++;
   size = m;
   degree = new int[m];
   first = new adjptr[m];
   last = new adjptr[m];
   position = new adjptr[m];
   for (int i = 0; i < m; i++)
   {
      degree[i] = 0;
      first[i] = NULL;
      last[i] = NULL;
      position[i] = NULL;
   }
} // constructor


adjlists::~adjlists()
{
   adjptr   helpptr;

   for (int i = 0; i < size; i++)
     while (first[i] != NULL)
     {
        helpptr = first[i];
        first[i] = first[i]->next;
        delete helpptr;
     }
   delete degree;
   delete first;
   delete last;
   delete position;
  
} // destructor


int adjlists::end_of_list(int m)
{
   if (m < 0 || m >= size)
   {
      printf("class adjlists: wrong access at end_of_list\n");
      return FALSE;
   }
   else
   {
      if (position[m] == NULL)
         return TRUE;
      else
         return FALSE;
   }
} // end_of_list


int adjlists::read_next_node(int m)
{
   if (m < 0 || m >= size)
   {
      printf("class adjlists: wrong access at read_next_node\n");
      return FALSE;
   }
   else
   {
      int node = position[m]->vertice;
      position[m] = position[m]->next;
      return node;
   }
} // read_next_node


void adjlists::insert_edge(int node1,int node2)
{
   adjptr   helpptr1,helpptr2;

   if (node1<0 || node2<0 || node1>=size || node2>= size)
      printf("class adjlists: wrong access at insert_edge \n");
   else
   {
      helpptr1 = new nachbar;
      helpptr2 = new nachbar;
      helpptr1->vertice = node2;
      helpptr2->vertice = node1;
      helpptr1->marked = FALSE;
      helpptr2->marked = FALSE;
      helpptr1->next = NULL;
      helpptr2->next = NULL;
      helpptr1->linkage = helpptr2;
      helpptr2->linkage = helpptr1;
      degree[node1]++;
      degree[node2]++;
      if (first[node1] == NULL)
      {
         first[node1] = helpptr1;
         last[node1] = helpptr1;
         position[node1] = helpptr1;
         helpptr1->pre = NULL;
      }
      else
      {
         helpptr1->pre = last[node1];
         last[node1]->next = helpptr1;
         last[node1] = helpptr1;
      }
      if (first[node2] == NULL)
      {
         first[node2] = helpptr2;
         last[node2] = helpptr2;
         position[node2] = helpptr2;
         helpptr2->pre = NULL;
      }
      else
      {
         helpptr2->pre = last[node2];
         last[node2]->next = helpptr2;
         last[node2] = helpptr2;
      }
   }
} // insert_edge



void adjlists::mark_old_edge(int m)
{
  adjptr  helpptr;
 
  if (m<0 || m>=size)
     printf("class adjlists: wrong access at mark_old_edge\n");
  else
  {
     if (position[m] == NULL)
        helpptr = last[m];
     else if (position[m]->pre != NULL)
        helpptr = position[m]->pre;
     else
        printf("class adjlists: mark_old_edge: position = first\n");
  }
  helpptr->marked = TRUE;
  if (helpptr->linkage != NULL)
     helpptr->linkage->marked = TRUE;
  else
     printf("class adjlists: wrong access at mark_old_edge using linkage\n");
} // mark_old_edge






int adjlists::old_edge_marked(int m)
{
  adjptr  helpptr;
 
  if (m<0 || m>=size)
     printf("class adjlists: wrong access at old_edge_marked:\n");
  else
  {
     if (position[m] == NULL)
        helpptr = last[m];
     else if (position[m]->pre != NULL)
        helpptr = position[m]->pre;
     else
        printf("class adjlists: old_edgemarked: position = first\n");
  }
  return helpptr->marked;
} // old_edge_marked
  

void adjlists::start_at_first_node(int m)
{ 
  if (m<0 || m>=size)
     printf("class adjlists: wrong access at start_at_first_node\n");
  else
     position[m] = first[m];
} // start_at_first_node

int adjlists::node_degree(int m)
{      
  if (m<0 || m>=size)
  {
     printf("class adjlists: wrong access at node_degree\n");
     return FALSE;
  }
  else
     return degree[m];
} // node_degree



void adjlists::delete_old_edge(int m)
{
  adjptr  helpptr, linkptr;

  if (m<0 || m>=size)
     printf("class adjlists: wrong access at delete_old_edge \n");
  else
  {
     if (position[m] == NULL)
        helpptr = last[m];
     else if (position[m]->pre != NULL)
        helpptr = position[m]->pre;
     else
        printf("class adjlists: delete_old_edge: position = first\n");
  }
  linkptr = helpptr->linkage;
  int n = helpptr->vertice;
  degree[m]--;
  degree[n]--;
  if (helpptr == first[m])
  {
     first[m] = first[m]->next;
     if (last[m] == helpptr)
        last[m] = last[m]->next;   // (position does not point to first !!)
     if (first[m] != NULL)
        first[m]->pre = NULL;
     if (helpptr != NULL)
       delete helpptr;
     else printf("class adjlists: delete_old_edge: free unallocated memory 1\n");
  }
  else
  {
     helpptr->pre->next = helpptr->next;
     if (last[m] == helpptr)
        last[m] = helpptr->pre;
     else
        helpptr->next->pre = helpptr->pre;
     if (helpptr != NULL)
       delete helpptr;
     else printf("class adjlists: delete_old_edge: free unallocated memory 2\n");
  }
  if (linkptr == first[n])
  {
     first[n] = first[n]->next;
     if (last[n] == linkptr)
        last[n] = last[n]->next;
     if (position[n] == linkptr)
        position[n] = position[n]->next;
     if (first[n] != NULL)
        first[n]->pre = NULL;
     if (linkptr != NULL)
       delete linkptr;
     else printf("class adjlists: delete_old_edge: free unallocated memory 3\n");
  }
  else
  {
     linkptr->pre->next = linkptr->next;
     if (last[n] == linkptr)
        last[n] = linkptr->pre;
     else
        linkptr->next->pre = linkptr->pre;
     if (position[n] == linkptr)
        position[n] = position[n]->next;
     if (linkptr != NULL)
       delete linkptr;
     else printf("class adjlists: delete_old_edge: free unallocated memory 4\n");
  }
} // delete_old_edge






void adjlists::delete_edge(int node1,int node2)
{
   adjptr  helpptr = NULL;
   adjptr  neighbor = NULL;
   int     found = FALSE;

   if (node1<0 || node2<0 || node1 >= size || node2 >= size)
      printf("class adjlists: wrong access at delete_edge\n");
   else
   {
      helpptr = first[node1];
      if (helpptr->vertice == node2)
      {
         found = TRUE;
         neighbor = helpptr->linkage;
      }
      while (!found)
      {
         helpptr = helpptr->next;
         if (helpptr->vertice == node2)
         {
            found = TRUE;
            neighbor = helpptr->linkage;
         }
      }
      if (found)
      {
         if (helpptr == first[node1])
         {
            first[node1] = first[node1]->next;
            if (first[node1] != NULL)
               first[node1]->pre = NULL;
         }
         else if (helpptr == last[node1])
         {
            last[node1] = last[node1]->pre;
            if (last[node1] != NULL)
               last[node1]->next = NULL;
         }
         else
         {
            helpptr->next->pre = helpptr->pre;
            helpptr->pre->next = helpptr->next;
         }
         if (helpptr == position[node1])
            position[node1] =  position[node1]->next;
            
         if (neighbor == first[node2])
         {
            first[node2] = first[node2]->next;
            if (first[node2] != NULL)
               first[node2]->pre = NULL;
         }
         else if (neighbor == last[node2])
         {
            last[node2] = last[node2]->pre;
            if (last[node2] != NULL)
               last[node2]->next = NULL;
         }
         else
         {
            neighbor->next->pre = neighbor->pre;
            neighbor->pre->next = neighbor->next;
         }
         if (neighbor == position[node2])
            position[node2] = position[node2]->next;

         degree[node1]--;
         degree[node2]--;
         if (helpptr != NULL)
            delete helpptr;
         else printf("class adjlists: delete_edge: free unallocated memory 1\n");
         if (neighbor != NULL)
            delete neighbor;
         else printf("class adjlists: delete_edge: free unallocated memory 1\n");
      }
   }
} // delete_edge

      
      
   
