/*****************************************************************

            Filename    :  basic_tree.cc

	    Version     :  01.1995

	    Author      :  Sebastian Leipert

	    Language    :  C++

            Purpose     :  See .h File.

	    Last Change :  05.12.97

******************************************************************/


#include <AGD/impl/TreeLayout/basic_tree.h>
#include <iostream.h>
#include <string.h>





/************************************************************************
                         PUBLIC

             This part contains all public files
*************************************************************************/



/************************************************************************
                         constructor
*************************************************************************/


basic_tree::basic_tree()

{
   node_nb = 0;
   edge_nb = 0;

   standard = FALSE;
   
   root = NULL;
   
   vbcEdgeArray = NULL;
   vbcNodeArray = NULL;

   array_size = 0;

}



/************************************************************************
                         destructor
*************************************************************************/


basic_tree::~basic_tree()
{
   int i = 0;
   delete[] vbcEdgeArray;
   for ( i = 1; i <= (array_size == 0 ? node_nb : array_size); i++)
   {
      delete vbcNodeArray[i];
   }
   delete[] vbcNodeArray;
}


void basic_tree::newTree()
{
   int i = 0;
   if (node_nb > 0)
   for (i = 1; i <= node_nb; i++)
      vbcNodeArray[i] = new vbc_node(i, 1.0, 1.0, 1.0, 1, 1);

//        double = 0, double = 0, double = 0, double = 0,
//        vbc_node * = 0,vbc_node * = 0,vbc_node * = 0,vbc_node * = 0,vbc_node * = 0);
}



/************************************************************************
                      getnode_edge_first
*************************************************************************/


int   basic_tree::getnode_edge_first(int i) const

   // Returns the tail of the edge i. 
{
   if (i <= edge_nb && i > 0)
      return vbcEdgeArray[i].get_first();
   else
   {
      cout << "Tree::getnode_edge_first: wrong access" << endl;
      return 0;
   }
}



/************************************************************************
                      getnode_edge_sec
*************************************************************************/


int   basic_tree::getnode_edge_sec(int i) const

   // Returns the head of the edge i. 
{
   if (i <= edge_nb && i > 0)
      return vbcEdgeArray[i].get_second();
   else
   {
      cout << "Tree::getnode_edge_sec: wrong access" << endl;
      return 0;
   }
}




/************************************************************************
                      get_node_nb
*************************************************************************/


int  basic_tree::get_node_nb() const

   // Returns the number of nodes in the tree.
{
   return node_nb;
}





/************************************************************************
                        get_Xcoord
*************************************************************************/


double  basic_tree::get_Xcoord(int i) const

   // Returns the x-coordinate of node i.
{
   if (i <= node_nb && i > 0)
      return vbcNodeArray[i]->get_Xcoord();
   else
   {
      cout << "basic_tree::get_Xcoord: wrong acces"
           << " at node " << i << endl;
      return 0;
   }
}

   

/************************************************************************
                        get_Ycoord
*************************************************************************/


double  basic_tree::get_Ycoord(int i) const

    // Returns the y-coordinate of node i.
{
   if (i <= node_nb && i > 0)
      return vbcNodeArray[i]->get_Ycoord();
   else
   {
      cout << "basic_tree::get_Ycoord: wrong acces"
           << " at node " << i << endl;
      return 0;
   }

}





/************************************************************************
                        get_Radius
*************************************************************************/


double  basic_tree::get_Radius(int i) const

    // Returns the y-coordinate of node i.
{
   if (i <= node_nb && i > 0)
      return vbcNodeArray[i]->get_radius();
   else
   {
      cout << "basic_tree::get_Ycoord: wrong acces"
           << " at node " << i << endl;
      return 0;
   }

}





/************************************************************************
                     get_node_info
*************************************************************************/


char* basic_tree::get_node_info(int i) const

    // Returns the information stored by node i.
{
   if (i <= node_nb && i > 0)
      return vbcNodeArray[i]->get_information();
   else
   {
      cout << "basic_tree::get_node_info: wrong access" 
           << " at node " << i << endl;
      return NULL;
   }
}




/************************************************************************
                     get_node_short
*************************************************************************/


char* basic_tree::get_node_short(int i) const

    // Returns the short information stored by node i.
{
   if (i <= node_nb && i > 0)
      return vbcNodeArray[i]->get_shortinfo();
   else
   {
      cout << "basic_tree::get_node_short: wrong access"
           << " at node " << i << endl;
      return NULL;
   }
}




/************************************************************************
                     get_node_colour
*************************************************************************/


int  basic_tree::get_node_colour(int node) const

    // Returns the colour stored by node.
{
   if (node <= node_nb && node > 0)
      return vbcNodeArray[node]->get_colour();
   else
   {
      cout << "basic_tree::get_node_colour: wrong access"
           << " at node " << node << endl;
      return 0;
   }

}




/************************************************************************
                     get_under_colour
*************************************************************************/


int  basic_tree::get_under_colour(int node) const

    // Returns the underlying colour stored by node.
{
   if (node <= node_nb && node > 0)
      return vbcNodeArray[node]->get_underlying_colour();
   else
   {
      cout << "basic_tree::get_under_colour: wrong access"
           << " at node " << node << endl;
      return 0;
   }
}




/************************************************************************
                      is_standard
*************************************************************************/


int  basic_tree::is_standard() const

   // Returns whether the tree contains standard information.
{
   return standard;
}



/************************************************************************
                     is_displayed
*************************************************************************/


int  basic_tree::is_displayed(int node) const

    // Returns if the node is displayed.
{
   if (node <= node_nb && node > 0)
      return vbcNodeArray[node]->is_displayed();
   else
   {
      cout << "basic_tree::is_displayed: wrong access"
           << " at node " << node << endl;
      return 0;
   }

}




/************************************************************************
                     is_highlighted
*************************************************************************/


int  basic_tree::is_highlighted(int node) const

    // Returns if the node i is highlighted.
{
   if (node <= node_nb && node > 0)
      return vbcNodeArray[node]->is_highlighted();
   else
   {
      cout << "basic_tree::is_highlighted: wrong access"
           << " at node " << node << endl;
      return 0;
   }
}





/************************************************************************
                      set_standard
*************************************************************************/


void  basic_tree::set_standard(int t)

   // Sets whether the tree contains standard information.
{
   standard = t;
}




/************************************************************************
                     set_node_colour
*************************************************************************/


void  basic_tree::set_node_colour(int node,int colour)

   // Set the colour of a node.
{ 
   if (node <= node_nb && node > 0)
      vbcNodeArray[node]->set_colour(colour);
   else
      cout << "basic_tree::set_node_colour: wrong access"
           << " at node " << node << endl;
}




/************************************************************************
                     set_under_colour
*************************************************************************/


void basic_tree::set_under_colour(int node,int colour)

   // Set the underlying colour of a node.
{ 
   if (node <= node_nb && node > 0)
      vbcNodeArray[node]->set_underlying_colour(colour);
   else
      cout << "basic_tree::set_under_colour: wrong access"
           << " at node " << node << endl;
}




/************************************************************************
                        display
*************************************************************************/


void  basic_tree::display(int node,int number)

   // Set if the node is displayed.
{ 
   if (node <= node_nb && node > 0)
      vbcNodeArray[node]->display(number);
   else
      cout << "basic_tree::display: wrong access"
           << " at node " << node << endl;
      
}





/************************************************************************
                     highlight
*************************************************************************/


void basic_tree::highlight(int node,int number)

   // Set if the node is highlighted.
{ 
   if (node <= node_nb && node > 0)
      vbcNodeArray[node]->highlight(number);
   else
      cout << "basic_tree::highlight: wrong access"
           << " at node " << node << endl;
}




/************************************************************************
                     tree_empty
*************************************************************************/


int  basic_tree::tree_empty()

   // Returns if the root is empty or not.
{
//   cout << "tree_empty: Root : " << root->get_nmber() << endl;
   if (root == NULL)
      return TRUE;
   else
      return FALSE;
}
